
import * as React from 'react';
import * as _ from 'lodash';

import { connectPropsToDatastore } from 'src/data/store';
import * as d3m from 'd3m/dist';

import ColumnTypeFilters from './ColumnTypeFilters';
import ColumnDistributionPlot from './ColumnDistributionPlot';
import { Row, Col } from 'react-bootstrap';
import DataSelector from '../DataSelector';
import ReactTable, { Column as ReactTableColumn } from 'react-table';
import { getFilesSample } from '../../../data/Api';
import * as Icon from 'react-feather';
import styled from 'styled-components';
import * as api from '../../../data/Api';

const DEFAULT_COLUMN_COUNT = 12;
const DEFAULT_PAGE_SIZE = 20;

enum dataViews {
  SPREADSHEET_VIEW = 'Spreadsheet view',
  DETAIL_VIEW = 'Detail view',
  COLUMNS_VIEW = 'Columns view',
}

const Badge = styled.div`
  display: inline-block;
  height: 18px;
  padding: 2px 5px;
  border-radius: 5px;
  color:  white;
  margin: 2px 5px;
  font-size: 8px;
  background-color: ${({color}) => color || '#57068C'};
`;
interface NavViews {
  labelView: string;
  iconComponent: React.ComponentType<Icon.Props>;
}

interface IconIProps {
  iconComponent: React.ComponentType<Icon.Props>;
}

class IconTest extends React.Component<IconIProps> {
  render() {
    const { iconComponent: IconComponent } = this.props;
    return (
      <IconComponent className="feather" style={{width: 18, height: 18, strokeWidth: 2}} />
    );
  }
}

interface DefineProblem {
  target?: string;
  type?: string;
  subType?: string;
}

function getFeatureID(c: string, resourceID: string): string {
  return `${resourceID}:${c}`;
}

interface TableViewProps {
  dataset: d3m.Dataset;
  resource: d3m.DataResource;
  data: d3m.ColumnProfile[];
  numRows: number;
  defineProblemObject: DefineProblem;
  rawData: d3m.ResourceFileData[]; // d3m.ColumnProfile[];
  getRawData: (dataset: d3m.Dataset, resource: d3m.DataResource,
               size?: number, start?: number) => d3m.ResourceFileData[];
  iconComponent: React.ComponentType<Icon.Props>;
}

interface TableViewState {
  columnTypeFilter: string[];
  selected: string[];
  page: number;
  sampleRawData: d3m.ResourceFileData[];
  loading: boolean;
  selectedView: string;
}

class TableView extends React.Component<TableViewProps, TableViewState> {

  private columnSpreadsheetVIEW: ReactTableColumn<d3m.ResourceFileData>[]  = [
    ...this.props.resource.columns!.map((column: d3m.Column, i) => ({
        Header: () => {
          const isTarget = this.isTarget(column);
          const data = this.getColumnData(column, this.props.data);
          return <>
          {
            this.selectIcon(data)
          }
          <b>{column.colName}</b>
          {isTarget && <Badge color="#068c39">Target</Badge>}
          </>;
      },
        id: 'columnSpreadsheetVIEW_' + column.colIndex.toString(),
        sortable: false,
        minWidth: 200,
        accessor: (v: d3m.ResourceFileData): string => {
          return v[column.colName];
        },
      })),
  ];

  private columnDetailVIEW: ReactTableColumn<d3m.ResourceFileData>[] = [
    ...this.props.resource.columns!.map((column: d3m.Column, i) => ({
      Header: () => {
        const data = this.getColumnData(column, this.props.data);
        // Be careful that data row is generated by react-table.
        // The original solution is saved in the field "_original".
        const isTarget = this.isTarget(column);
        return <div key={i.toString()} style={{overflow: 'auto', marginBottom: 0}}>
          <div style={{borderBottom: '1px solid #cccccc', fontSize: 16, paddingBottom: 5, marginBottom: 10}}>
          {
            this.selectIcon(data)
          }
          <strong> <b>{column.colName}</b></strong>{isTarget && <Badge color="#068c39">Target</Badge>}
          </div>
          <ColumnDistributionPlot
            target={isTarget}
            data={this.getColumnData(column, this.props.data)}
            showXLabel={false}
            showYLabel={false}
            showInfo={false}
            numWords={20}
            numColumns={2}
            heightTextContainer={200}
            widthTextContainer={200}
            />
        </div>;
      },
      id: 'columnDetailVIEW_' + column.colIndex.toString(),
      minWidth: 200,
      sortable: false,
      accessor: (v: d3m.ResourceFileData): string => {
        return v[column.colName];
      },
      })),
  ];

  constructor(props: TableViewProps) {
    super(props);
    this.state = {
      columnTypeFilter: this.getColumnTypes(this.props.resource.columns || []),
      selected: this.props.data.filter(columnProfile => columnProfile.column.role.indexOf(d3m.ColumnRole.index) === -1)
        .slice(0, DEFAULT_COLUMN_COUNT).map(d => d.column.colName),
      page: 0,
      sampleRawData: this.props.getRawData(this.props.dataset, this.props.resource!, DEFAULT_PAGE_SIZE, 0),
      loading: false,
      selectedView: dataViews.DETAIL_VIEW,
    };
  }

  selectIcon (data: d3m.ColumnProfile) {
    const IconComponent: React.ComponentType<Icon.Props> = data.column.colName === 'd3mIndex' ?
    Icon.Key
    :
    data.column.colType === d3m.ColumnType.dateTime ?
    Icon.Calendar
    :
    data.column.colType === d3m.ColumnType.real || data.column.colType === d3m.ColumnType.integer ?
    Icon.Hash
    :
    data.column.colType === d3m.ColumnType.categorical || data.column.colType === d3m.ColumnType.string ?
    Icon.Type
    :
    Icon.ArrowRight;
    // case d3m.ColumnType.json:
    // case d3m.ColumnType.realVector:
    // case d3m.ColumnType.geojson:
    return <IconComponent className="feather icon-muted" />;
  }

  isTarget(column: d3m.Column): boolean {
    const isTarget = this.props.defineProblemObject.target ?
            (this.props.defineProblemObject.target === getFeatureID(column.colName, this.props.resource.resID)
            ||
            getFeatureID(this.props.defineProblemObject.target, this.props.resource.resID) ===
            getFeatureID(column.colName, this.props.resource.resID)
            )
            :
            false;
    return isTarget;
  }
  /**
   * Returns a list of selected columns.
   */
  getSelectedColumns(): d3m.Column[] {
    return this.state.selected.map(selected =>
      (this.props.resource.columns || []).find(column => column.colName === selected) as d3m.Column);
  }

  /**
   * Returns a list of available column types.
   */
  getColumnTypes(columns: d3m.Column[]): string[] {
    return _.uniq(columns.map(column => column.colType).sort()) as string[];
  }

  /**
   * Filters the columns based on column type.
   */
  filterColumnsByType = (columns: d3m.Column[]): d3m.Column[] => {
    return columns.filter(column => {
      return this.state.columnTypeFilter.indexOf(column.colType) !== -1;
    });
  }

  onSelectedChange = (selected: string[]) => {
    this.setState({ selected });
  }

  onColumnTypeFilterChange = (columnTypeFilter: string[]) => {
    this.setState({ columnTypeFilter });
  }

  getColumnData(column: d3m.Column, data: d3m.ColumnProfile[]) {
    return data.find(c => c.column.colIndex === column.colIndex)!;
  }

  async onPageChangeTable(pageIndex: number) {
    this.setState({loading: true});
    try {
      const r = await getFilesSample(this.props.dataset.about.datasetID, (this.props.resource.resID!),
                                     DEFAULT_PAGE_SIZE, pageIndex * DEFAULT_PAGE_SIZE);
      let copySampleRawData = this.state.sampleRawData;
      let arrayTemp = (pageIndex === 0)
        ? r :
        (pageIndex < this.state.page)
          ? copySampleRawData.splice(0, pageIndex * DEFAULT_PAGE_SIZE).concat(r)
          : copySampleRawData.concat(r);
      this.setState({ loading: false, sampleRawData: arrayTemp, page: pageIndex });
    } catch (e) {
      this.setState({ loading: true });
    }
  }

  render() {
    const { data, numRows, resource } = this.props;
    const numCols = resource.columns ? resource.columns.length : 0;
    let columns = this.getSelectedColumns();
    const augQuality = this.props.dataset
        .qualities &&
        this.props.dataset
          .qualities
          .find(f => f.qualName === 'augmentation_info');

    const augQualityValue: d3m.Dict | undefined = augQuality ? augQuality.qualValue as d3m.Dict : undefined;
    columns = this.filterColumnsByType(columns || []);
    const columnTypes = this.getColumnTypes(resource.columns || []);

    // Defining the three types of views
    const views: NavViews [] = [
      {labelView: dataViews.SPREADSHEET_VIEW, iconComponent: Icon.Grid},
      {labelView: dataViews.DETAIL_VIEW, iconComponent: Icon.BarChart},
      {labelView: dataViews.COLUMNS_VIEW, iconComponent: Icon.Sidebar},
    ];
    const columnData = this.state.selectedView === dataViews.SPREADSHEET_VIEW ? this.columnSpreadsheetVIEW
                       : this.state.selectedView === dataViews.DETAIL_VIEW ? this.columnDetailVIEW
                       : [];

    return (
      <>
    <div className="d-flex">
      <div className="w-100">
        <Row>
          <Col md={10} key={'info'}>
          <div className="mb-2" style={{fontSize: '14px'}}>
            <span className="mr-3"><b>Number of Columns: </b>{numCols}</span>
            <span><b>Number of Rows:</b> {numRows} {
              augQualityValue && augQualityValue.augmentation_type === 'union'
              ? ` (${numRows - (augQualityValue.nb_rows_before as number)} added)`
              : ''
            }</span>
          </div>
          </Col>
          <Col md={2} key={'views'} style={{textAlign: 'right'}}>
          <nav className="d-flex">
          <a>Views</a>
          <ul className="nav row" style={{marginLeft: 0}}>
          {
            views.map((d, index) => {
              const selectedView = this.state.selectedView;
              return (
                <div key={ 'NavWorkflow_' + index} className="col-md-1 align-items-center">
                  <button className={d.labelView ===  selectedView ? 'nav-item nav-link active' : 'nav-item nav-link'}
                          style={ d.labelView ===  selectedView ?
                            {color: '#63508b', borderColor: '#63508b'} :
                            {color: 'silver'}
                          }
                          onClick={() => {
                            this.setState({ selectedView: d.labelView });
                            api.log(d3m.UserEvent.CHANGE_VIEW, {typeView: d.labelView});
                          }
                          }>
                      <IconTest iconComponent={d.iconComponent} />
                  </button>
                </div>
              );
            })
          }
          </ul>
        </nav>
          </Col>
        </Row>

        <div className="card mt-2 mb-2" style={{marginBottom: 20}}>
          {
            this.state.selectedView === dataViews.SPREADSHEET_VIEW ||  this.state.selectedView === dataViews.DETAIL_VIEW
            ?
            <>
            {/* )-----------------Spreadsheet view (1) or Detail view (2)----------------- */}
            <ReactTable
              data={ this.state.sampleRawData }
              columns={columnData}
              pageSize={20}
              pages={Math.ceil(numRows / DEFAULT_PAGE_SIZE)}
              showPageSizeOptions={false}
              showPageJump={false}
              page={this.state.page}
              loading={this.state.loading}
              onPageChange={(pageIndex) => {
                this.onPageChangeTable(pageIndex);
                api.log(d3m.UserEvent.EXPLORE_SPREADSHEET, {indexPage: pageIndex});
              }
              }
            />
            </>
            :
            <>
            {/* --------------------------------------Column view-------------------------- */}
            <div>
              <DataSelector
                data={this.props.data.map(d => ({ name: d.column.colName }))}
                selected={this.state.selected}
                onSelectedChange={this.onSelectedChange}
              />
            </div>
            <ColumnTypeFilters
              columnTypes={columnTypes}
              columnTypeFilter={this.state.columnTypeFilter}
              onColumnTypeFilterChange={this.onColumnTypeFilterChange}
            />
            <Row>
              {
                columns.map((column: d3m.Column) =>
                  <Col md={this.getColumnData(column, data).isText ? 8 : 4 } key={column.colName}>
                    <div className="card mb-4" style={{overflow: 'auto'}}>
                      <ColumnDistributionPlot
                        target={this.isTarget(column)}
                        data={this.getColumnData(column, data)}
                        showXLabel={true}
                        showYLabel={true}
                        showInfo={true}
                        />
                    </div>
                  </Col>)
              }
            </Row>
            </>
          }
        </div>
      </div>
    </div>
      </>
    );
  }
}

export default connectPropsToDatastore<TableViewProps>((store, ownProps) => ({
  getRawData: store.getRawData,
  dataset: store.selectedDataset,
  data: store.dataForResource(ownProps.resource!) as d3m.ColumnProfile[],
  defineProblemObject: store.problemDefinition,
  numRows: store.resourceNumRows(ownProps.resource!),
}))(TableView);
